# Vivliostyle.js

JavaScript Library for HTML+CSS typesetting and rich paged viewing with EPUB/Web publications support.

(Source code of Vivliostyle.js is [now written in TypeScript](https://github.com/vivliostyle/vivliostyle.js/tree/master/src/ts).)

## Try Vivliostyle.js

[Vivliostyle Viewer samples](https://vivliostyle.org/samples/)

## Bug reports & feature requests

Please send them to

- [GitHub Issues](https://github.com/vivliostyle/vivliostyle.js/issues)

## Using Vivliostyle.js

### Using Vivliostyle Viewer package

Download the Vivliostyle Viewer package from <https://vivliostyle.org/download/> and follow the instruction in it.

See [Vivliostyle Viewer User’s Guide](https://vivliostyle.github.io/vivliostyle.js/docs/en/)

See <https://github.com/vivliostyle/vivliostyle-ui> for source code of the UI.

### Using vivliostyle-savepdf CLI tool

See [vivliostyle-savepdf](https://github.com/vivliostyle/vivliostyle-savepdf/), the save PDF command line tool with Vivliostyle and headless Chrome.

### Integrating Vivliostyle.js into web sites

Vivliostyle.js can be installed from [npm](https://www.npmjs.com/package/vivliostyle):

```
npm install vivliostyle
```

See [API Reference](https://github.com/vivliostyle/vivliostyle.js/blob/master/doc/api.md).

#### Using vivliostyle-print library

See [vivliostyle-print](https://github.com/vivliostyle/vivliostyle-print/) for integrating printing with Vivliostyle.

## Development

See [Vivliostyle.js Development](https://github.com/vivliostyle/vivliostyle.js/wiki/Development).

## License

Licensed under [AGPL Version 3](http://www.gnu.org/licenses/agpl.html).

Vivliostyle.js is implemented based on [Peter Sorotokin's EPUB Adaptive Layout implementation](https://github.com/sorotokin/adaptive-layout), which is licensed under [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0).

Vivliostyle.js contains following components:

- [fast-diff](https://www.npmjs.com/package/fast-diff)
  - Licensed under [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0)

## Other Documentation

- [Vivliostyle Viewer User’s Guide](https://vivliostyle.github.io/vivliostyle.js/docs/en/)

- [Vivliostyle Documentation](https://vivliostyle.org/docs/)
